//17.11.2022
//by Reptiloid software

/*
 
Даний приклад коду є демонстраційним. Це базовий приклад, який циклічно плавно збільшує та зменшує потужність, 
яка виділяється на споживачі шляхом "різання" синусоїди (традиційне дімірування)

 

Обмеження:
- Для контролю фази використовувати  тільки  D2 (переривання INT0)  
 (порт M2 дімера підключати до порту D2 АРДУІНО)!!!
- Не використовувати піни D9 и D10 для PWM Analog.Write()!!!
  тільки  цифровий  вхід/вихід digitalWrite() та digitalRead()


Функціонал:
- Дана бібліотека дозволяє керувати навантаженням,
  що підключені  в мережу  220В перемінного струму за допомогою АУРДУІНО

Як працювати:
1) Підключити бібліотеку AC_Dimmer.h
2) Присвоїти номер дімеру (нумерація від 0!!!), що використовується в проекті
   #define <"ім’я дімера"> <"порядковий номер">

   
   Наприклад:   
            #include <AC_Dimmer.h>
            
            #define Dimmer_1 0
            
            
3) Ініціалізувати  дімер в void setup().
   - Ініціалізація проводиться між функціями Dimmer_init_begin() и Dimmer_init_end();
   - Ініціалізація піна Ардуіно, до якого підключений дімер відбувається за допомого функції  Dimmer_pin_assign():, де

        Dimmer_pin_assign(<"ім’я дімера">, <"порт(пін) ардуіно дімера">);

      Наприклад, ось так ініціалізувати дімер, що підключений на ПІН Д4: 
                void setup()
                {
                  Dimmer_init_begin();
    
                    Dimmer_pin_assign(Dimmer_1, 4);  
                          
                  Dimmer_init_end();
                }          

      
3) В void loop() використовувати  Dimm_value для регулювання потужності: 
                   
   - Dimm_value(<"ім’я дімера">, <"значення потужності  від 0 до 255">)
   
наприклад:  

             void loop()
            {
                
             Dimm_value(Dimmer_1, 128);     //50% потужності на дімері                                          
             
              
               
            }


*/


#include <AC_Dimmer.h> 
 
 //підключаємо бібліотеку, 
                 
 
#define Dimmer_1 0 //присвоюємо номер дімеру. В даному випадку, №0
 
int brightness = 0;    // змінна, що задає потужність
 
void setup() 
{ 
  Dimmer_init_begin(); 
     
  Dimmer_pin_assign(Dimmer_1, 4);   //ініціалізовуємо дімер №0, що підключений на ПІН Д4: 
  
 // - Для контролю фази використовувати  тільки  D2 (переривання INT0)  
 //(порт M2 дімера підключати до порту D2 АРДУІНО)!!!
    
  Dimmer_init_end(); 
} 
 
  
#define TOP 255
#define BOT 1

int dir = 0; 

void loop() {

if(dir == 0) { brightness++; }  //збільшуємо потужність
else { brightness--; }          //зменшуємо потужність

if(brightness == TOP) { dir = 1; }
if(brightness == BOT) { dir = 0; }
   
 Dimm_value(Dimmer_1, brightness); //саме ця функція регулює потужність
 delay(10); 
}
