//17.11.2022
//by Reptiloid software

/*
Даний приклад коду є демонстраційним. Приклад дозволяє працювати із декількома прикладами одночасно
Це більш розширений приклад, по відношенню до звичайного FADE.
Даний приклад циклічно плавно збільшує та зменшує потужність, 
яка виділяється на споживачі шляхом "різання" синусоїди (традиційне дімірування)

Обмеження:
- Для контролю фази використовувати  тільки  D2 (переривання INT0)  
 (порт M2 дімера підключати до порту D2 АРДУІНО)!!!
- Не використовувати піни D9 и D10 для PWM Analog.Write()!!!
  тільки  цифровий  вхід/вихід digitalWrite() та digitalRead()

Функціонал:
- Дана бібліотека дозволяє керувати навантаженням,
  що підключені  в мережу  220В перемінного струму за допомогою АУРДУІНО


Як працювати:
1) Підключити бібліотеку AC_Dimmer.h
2) Присвоїти номер дімеру (нумерація від 0!!!), що використовується в проекті
   #define <"ім’я дімера"> <"порядковий номер">

   
   Наприклад: (присвоюємо номера трьом дімерам )   
            #include <AC_Dimmer.h>
            
            #define Dimmer_1 0
            #define Dimmer_2 1
            #define Dimmer_3 2
            
3) 3) Ініціалізувати  дімер в void setup().
   - Ініціалізація проводиться між функціями Dimmer_init_begin() и Dimmer_init_end();
   - Ініціалізація піна Ардуіно, до якого підключений дімер відбувається за допомого функції  Dimmer_pin_assign():, де
        Dimmer_pin_assign(<"ім’я дімера">, <"порт(пін) ардуіно дімера">);


      Наприклад: 
                void setup()
                {
                  Dimmer_init_begin();
    
                          Dimmer_pin_assign(Dimmer_1, 3);  
                          Dimmer_pin_assign(Dimmer_2, A3);
                          Dimmer_pin_assign(Dimmer_3, A2);
    
                   Dimmer_init_end();
                }          

      
3) В void loop() використати потрібну  функцию: 
                   
   - Dimm_value(<"ім’я дімера">, <"значення потужності від 0 до 255">)
   - Heater(<"ім’я дімера">, <"значення потужності от 0 до 10">)
   - SSR_switch(<"ім’я дімера">, <значення 1 або 0 (HIGH/LOW)>)
  
наприклад:   void loop()
            {
                Dimm_value(Dimmer_3, 64);    //25% потужності на дімері №3
                Heater(Dimmer_2, 3);         //30% потужності на дімері №2 (за умови, що навантаження ТЕН чи інший  низькоінерційний прилад)
                Dimm_value(Dimmer_1, 128);   //50% потужності на дімері №1
                                            
              delay(1000);                    //встановлюємо параметри на 1 сек
              
                SSR_switch(Dimmer_3, LOW);  // виключаємо дімера
                SSR_switch(Dimmer_2, LOW);
                SSR_switch(Dimmer_1, LOW);
                
              delay(1000);
            }

Код цього прикладу передбачає плавне почергове запалення та
 гасіння трьох ламп розжарювання, підключених до ардуїно кожна через незалежний диммер

Демонстрацію можна подивитися тут:
https://www.youtube.com/watch?v=9fhkJQIRmEA


*/


#include <AC_Dimmer.h>
#include <math.h>    //якщо Ви хочете використовувати дану бібліотеку у своєму проекті,
                     //математична бібліотека

#define Dimmer_1 0
#define Dimmer_2 1
#define Dimmer_3 2

unsigned char i = 0;
unsigned char range = 70;  // діапазон регулювання
                           // (255 - максимальне значення)

void setup()
{
  Dimmer_init_begin();
    
   Dimmer_pin_assign(Dimmer_1, 3);  
   Dimmer_pin_assign(Dimmer_2, A3);
   Dimmer_pin_assign(Dimmer_3, A2);
    
  Dimmer_init_end();
}


void loop() 
{ 
   i++;
  
      Dimm_value(Dimmer_1, range*fabs(sin(i*2*3.14/255)));
      Dimm_value(Dimmer_2, range*fabs(sin((i+(255/3))*2*3.14/255)));
      Dimm_value(Dimmer_3, range*fabs(sin((i+(255*2/3))*2*3.14/255)));
      
   delay(25);
}
